unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, AxCtrls, StdCtrls,zobrazeni;

type
  TForm1 = class(TForm)
    TVStrom: TTreeView;
    ScrollBox1: TScrollBox;
    Thumbnail: TImage;
    procedure FormCreate(Sender: TObject);
    procedure addDirectory(parent: TTreeNode; dir: string);
    procedure TVStromChange(Sender: TObject; Node: TTreeNode);
    procedure createThumbnails(dir: string);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure TVStromKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ThumbnailDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


var
  Form1: TForm1;
  Thumbnails: array[1..100] of TImage;
  Labels: array[1..100] of TMemo;
  count: integer;
  ImageList: TStringList;
implementation

{$R *.dfm}
procedure TForm1.createThumbnails(dir: string);
var
  res: TSearchRec;
  EOFound: boolean;
  r: string;
  N,i: integer;
  ole: TOleGraphic;
  fs: TFileStream;
begin
  ImageList.Clear;
  N:=0;
  for i:= 1 to count do
  begin
    Thumbnails[i].Destroy;
    Labels[i].Destroy;
  end;
  EOFound:= False;
  if FindFirst(Dir+'*.*', faAnyFile , Res) < 0 then exit
  else
  begin
    while not EOFound do begin
      if (pos('.jpg', res.Name) >0)or(pos('.jpeg', res.Name) >0)
        or (pos('.JPG', res.Name) >0) or (pos('.JPEG', res.Name) >0)then
      begin
        ImageList.Add(dir+res.Name);
        inc(N);
        //Pridani obrazku mezi nahledy
        Labels[n]:=TMemo.Create(ScrollBox1);
        labels[n].parent:=ScrollBox1;
        labels[n].Left:=165;
        labels[n].Top:=5+(n-1)*120;
        labels[n].ReadOnly:=true;
        labels[n].Enabled:=false;
        labels[n].Lines.Append(  res.Name + ' - ' +IntToStr(res.size) + 'bajt');
        labels[n].Lines.Append('Zmnno: ' + DateTimeToStr(FiledateToDateTime(res.time)) );
        Thumbnails[n]:=TImage.Create(ScrollBox1);
        Thumbnails[n].Parent:=ScrollBox1;
          Thumbnails[n].Width:=160;
          Thumbnails[n].Height:=100;
          Thumbnails[n].Left:=5;
          Thumbnails[n].Top:=5+(N-1)*120;
          Thumbnails[n].Proportional:=true;
          Thumbnails[n].Stretch:=true;
          Thumbnails[n].Visible:=true;
          thumbnails[n].Refresh;
          thumbnails[n].Repaint;
          Thumbnails[n].Tag:=n;
          Thumbnails[n].OnDblClick:=Thumbnail.OnDblClick;
          try
            ole:=TOleGraphic.Create;
            fs:=TFileStream.Create(dir+res.Name,fmOpenRead or fmSharedenyNone);
            ole.LoadFromStream(fs);
            Thumbnails[n].Picture.Assign(ole);
            Labels[n].Lines.Append('Vka: ' + IntToStr(ole.Height)+'px');
            Labels[n].Lines.Append('ka: ' + IntToStr(ole.Height)+'px');
          finally
            fs.Free;
            ole.Free;
          end;

      end;
      EOFound:= FindNext(Res) <> 0;
    end;
  end;
  count:=N;
  FindClose(Res) ;
end;
procedure TForm1.addDirectory(parent: TTreeNode; dir: string);
var
  res: TSearchRec;
  EOFound: boolean;
  dirNode: TTreeNode;
  path: string;
begin
  parent.DeleteChildren;
  EOFound:= False;
   if FindFirst(Dir+'*.*', faAnyFile, Res) < 0 then
     exit
   else
     while not EOFound do begin
       if Pos('.', res.Name) <= 0 then
       begin
         dirNode:=TVStrom.Items.AddChild(parent, res.Name);
       end;
       EOFound:= FindNext(Res) <> 0;
     end;
   FindClose(Res) ;  
end;
procedure TForm1.FormCreate(Sender: TObject);
var
  dir: String;
  root: TTreeNode;
begin
  ImageList:=TStringList.Create;
  root:=TVStrom.Items.AddChild(nil,'C:');
  addDirectory(root,'C:\');
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if key = VK_ESCAPE then
    Application.Terminate;
end;

procedure TForm1.ThumbnailDblClick(Sender: TObject);
var
  f: TForm2;
begin
  f:=TForm2.Create(Form1);
  f.images:=ImageList;
  f.init(TImage(Sender).Tag);
  f.ShowModal;
end;

procedure TForm1.TVStromChange(Sender: TObject; Node: TTreeNode);
var
  dir: string;
  nod: TTreeNode;
begin
  nod:=node;
  while nod <> nil do
  begin
    dir:=nod.Text+'\'+dir;
    nod:=nod.Parent;
  end;
  addDirectory(node, dir);
  createThumbnails(dir);
end;

procedure TForm1.TVStromKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = VK_ESCAPE then
    Application.Terminate;
end;

end.
