unit zobrazeni;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, AxCtrls, ComCtrls;

type
  TForm2 = class(TForm)
    bFirst: TButton;
    bPrev: TButton;
    bNext: TButton;
    bLast: TButton;
    lOrder: TLabel;
    TBZoom: TTrackBar;
    lZoom: TLabel;
    ScrollBox1: TScrollBox;
    Image: TImage;
    infoPanel: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    lName: TLabel;
    lSize: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    lChanged: TLabel;
    lSizes: TLabel;
    Button1: TButton;
    Timer1: TTimer;
    Label5: TLabel;
    Label6: TLabel;
    procedure init(id: integer);
    procedure showImage(resize: boolean);
    procedure bFirstClick(Sender: TObject);
    procedure bLastClick(Sender: TObject);
    procedure bPrevClick(Sender: TObject);
    procedure bNextClick(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
    images: TStringList;
    index: integer;    
  end;

var
  Form2: TForm2;


implementation

{$R *.dfm}
procedure TForm2.showImage(resize:boolean);
var
  ole: TOleGraphic;
  fs: TFileStream;
  zoom: real;
  res: TSearchRec;
begin

  try
    if not resize then
    begin
      if (FindFirst(images.Strings[index-1],faAnyFile,res) >= 0) then
      begin
        Image.Width:=ClientWidth;
        Image.Height:=ClientHeight;
        ole:=TOleGraphic.Create;
        fs:=TFileStream.Create(images.Strings[index-1] ,fmOpenRead or fmSharedenyNone);
        ole.LoadFromStream(fs);
        Image.Picture.Assign(ole);
        lOrder.Caption:=IntToStr(index) + ' / ' + inttostr(images.Count);
        lSizes.Caption:=IntToStr(ole.Width) + ' x ' + inttostr(ole.Height);
        lChanged.Caption:=DateTimeToStr(FiledateToDateTime(res.time));
        if ole.Height > ole.Width then
          zoom:=(Image.Height*100)/Ole.Height
        else
          zoom:=(Image.Width*100)/Ole.Width;
        Label6.Caption:=IntToStr(round(zoom))+' %';
        lName.Caption:= res.Name;
        lSize.Caption:=IntToStr(res.Size) + ' bajt';
      end
      else exit;
    end;
  finally
    fs.Free;
    ole.Free;
    FindClose(res);
  end;
end;

procedure TForm2.Timer1Timer(Sender: TObject);
begin
  showImage(false);
  if (index +1) < Images.Count then
  begin
    inc(index);
  end
  else
  begin
    Timer1.Enabled:=false;
    Button1.Caption:='Pustit Slideshow';
  end;
end;

procedure TForm2.bFirstClick(Sender: TObject);
begin
  index:=1;
  showImage(false);
end;

procedure TForm2.bLastClick(Sender: TObject);
begin
  index:=images.Count;
  showImage(false);
end;


procedure TForm2.bNextClick(Sender: TObject);
begin
  if index < images.count then
  begin
    inc(index);
    showImage(false);
  end;
end;

procedure TForm2.bPrevClick(Sender: TObject);
begin
  if index > 1 then
  begin
    dec(index);
    showImage(false);

  end;
end;

procedure TForm2.Button1Click(Sender: TObject);
begin
  if Timer1.Enabled  then
    Button1.Caption:='Spustit Slideshow'
  else
  begin
    index:=1;
    Button1.Caption:='Vypnout Slideshow';
  end;  
  Timer1.Enabled:=not Timer1.Enabled;
end;

procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Timer1.Enabled:=false;
end;

procedure TForm2.FormKeyPress(Sender: TObject; var Key: Char);
begin
  case key of
  's','S':Button1Click(Button1);    
  end;
end;

procedure TForm2.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  case key of
  VK_HOME: bFirstClick(bFirst);
  VK_END: bLastClick(bLast);
  VK_PRIOR: bPrevClick(bPrev);
  VK_NEXT: bNextClick(bNext);
  VK_EXECUTE: Self.Close;
  VK_ESCAPE:begin
    if Timer1.Enabled then
      Timer1.Enabled:=false
    else
      Application.Terminate;
  end;
  end;
end;

procedure TForm2.init(id: integer);
begin
  index:=id;
  left:=0;
  top:=0;
  Width:=Screen.DesktopRect.Right-Screen.DesktopRect.Left;
  Height:=Screen.DesktopRect.Bottom-Screen.DesktopRect.Top-35;


  infoPanel.Top:=ClientHeight-50;
  infoPanel.Left:=670;
  ScrollBox1.Width:=ClientWidth;
  ScrollBox1.Height:=ClientHeight-50;
  Image.Width:=ClientWidth;
  Image.Height:=ClientHeight;
  Image.Left:=0;
  Image.Top:=0;
  Button1.Left:=450;
  button1.Top:=ClientHeight-45;
  bFirst.Left:=505;
  bFirst.Top:=ClientHeight-45;
  bPrev.Left:=543;
  bPrev.Top:=ClientHeight-45;
  bNext.Left:=581;
  bNext.Top:=ClientHeight-45;
  bLast.Left:=619;
  bLast.Top:=ClientHeight-45;
  lOrder.Left:=570;
  lOrder.Top:=ClientHeight-18;
  lOrder.Caption:=IntToStr(index) + ' / ' + inttostr(images.Count);
  TBZoom.Left:=5;
  TBZoom.Top:=ClientHeight-45;
  LZoom.Left:=5;
  lZoom.Top:=ClientHeight-18;
  lZoom.Caption:=IntToStr(TBZoom.Position);
  showImage(false);
end;
end.
